## ptl 2.3.1

=== source/CMakeLists.txt ===
# -------------------------------------------------------------------------------------- #
# # General                                        # #
# -------------------------------------------------------------------------------------- #
# Locate sources and headers for this project - headers are included so they will show up
# in IDEs
file(GLOB_RECURSE ptl_headers ${CMAKE_CURRENT_LIST_DIR}/PTL/*.hh
     ${CMAKE_CURRENT_LIST_DIR}/PTL/*.icc)
file(GLOB_RECURSE ptl_sources ${CMAKE_CURRENT_LIST_DIR}/*.cc)

# -------------------------------------------------------------------------------------- #
# # Config, Version                                # #
# -------------------------------------------------------------------------------------- #

configure_file(${PROJECT_SOURCE_DIR}/cmake/Templates/Config.hh.in
               ${CMAKE_CURRENT_BINARY_DIR}/PTL/Config.hh @ONLY)

list(APPEND ptl_headers ${CMAKE_CURRENT_BINARY_DIR}/PTL/Config.hh)

configure_file(${PROJECT_SOURCE_DIR}/cmake/Templates/Version.hh.in
               ${CMAKE_CURRENT_BINARY_DIR}/PTL/Version.hh @ONLY)

list(APPEND ptl_headers ${CMAKE_CURRENT_BINARY_DIR}/PTL/Version.hh)

# -------------------------------------------------------------------------------------- #
# # PTL Library                                     # #
# -------------------------------------------------------------------------------------- #

if(BUILD_SHARED_LIBS)

    ptl_build_library(
        TYPE SHARED
        TARGET_NAME ptl-shared
        OUTPUT_NAME ptl
        SOURCES ${ptl_headers} ${ptl_sources})

    target_link_libraries(ptl-shared PUBLIC Threads::Threads)
    if(PTL_USE_TBB)
        target_link_libraries(ptl-shared PUBLIC TBB::tbb)
    endif()

    target_include_directories(
        ptl-shared
        PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/source>
               $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
               $<INSTALL_INTERFACE:${PTL_INSTALL_INCLUDEDIR}>)

    if(PTL_USE_SANITIZER AND NOT ("${PTL_SANITIZER_TYPE}" STREQUAL "leak"))
        string(REPLACE " " ";" _sanitize_args "${ptl_sanitize_args}")
        set_target_properties(ptl-shared PROPERTIES INTERFACE_LINK_OPTIONS
                                                    "${_sanitize_args}")
    endif()

    export(
        TARGETS ptl-shared
        NAMESPACE PTL::
        FILE ${PROJECT_BINARY_DIR}/ptl-shared.cmake)
endif()

if(BUILD_STATIC_LIBS)

    ptl_build_library(
        TYPE STATIC
        TARGET_NAME ptl-static
        OUTPUT_NAME ptl
        SOURCES ${ptl_headers} ${ptl_sources})

    target_link_libraries(ptl-static PUBLIC Threads::Threads)
    if(PTL_USE_TBB)
        target_link_libraries(ptl-static PUBLIC TBB::tbb)
    endif()

    target_include_directories(
        ptl-static
        PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/source>
               $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
               $<INSTALL_INTERFACE:${PTL_INSTALL_INCLUDEDIR}>)

    export(
        TARGETS ptl-static
        NAMESPACE PTL::
        FILE ${PROJECT_BINARY_DIR}/ptl-static.cmake)
endif()

# -------------------------------------------------------------------------------------- #
# # Installation                                    # #
# -------------------------------------------------------------------------------------- #

if(PTL_INSTALL_CONFIG)
    # install export
    install(
        EXPORT ${PROJECT_NAME}Targets
        NAMESPACE PTL::
        DESTINATION ${PTL_INSTALL_CMAKEDIR}
        COMPONENT Development)
endif()

if(PTL_INSTALL_HEADERS)
    # headers
    install(
        FILES ${ptl_headers}
        DESTINATION ${PTL_INSTALL_INCLUDEDIR}/PTL
        COMPONENT Development)
endif()

=== debian/changelog ===
ptl (2.3.1-1build1) jammy; urgency=medium

  * No-change rebuild for libtbb soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Mar 2022 10:05:08 +0100

ptl (2.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * fix autopkgtest failure on armhf (Closes: #1001237)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 16 Dec 2021 17:32:19 +0100

ptl (2.3.0-1) unstable; urgency=medium

  * New upstream version 2.3.0

 -- Stephan Lachnit <stephanlachnit@debian.org>  Sat, 04 Dec 2021 12:45:11 +0100

ptl (2.2.0-1) unstable; urgency=medium

  * New upstream version 2.2.0

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 01 Dec 2021 14:29:47 +0100

ptl (2.1.0-1) unstable; urgency=medium

  * New upstream version 2.1.0

 -- Stephan Lachnit <stephanlachnit@debian.org>  Tue, 30 Nov 2021 20:08:06 +0100

ptl (2.0.0-3) unstable; urgency=medium

  * improve autopkgtest duration
  * remove warning if PTL_VERSION is not set in examples

 -- Stephan Lachnit <stephanlachnit@debian.org>  Mon, 29 Nov 2021 14:49:07 +0100

ptl (2.0.0-2) unstable; urgency=medium

  * fix autopkgtest failure on armhf (Closes: #996553)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 26 Nov 2021 01:09:34 +0100

ptl (2.0.0-1) unstable; urgency=medium

  * New upstream version 2.0.0
  * Update standards version to 4.6.0.1, no changes needed
  * Upload to unstable

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 13 Oct 2021 14:28:32 +0200

ptl (1.0.2-2) experimental; urgency=medium

  * Add missing dependency (Closes: #989110)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 27 May 2021 00:20:12 +0200

ptl (1.0.2-1) experimental; urgency=medium

  * Initial release. (Closes: #979413)

 -- Stephan Lachnit <stephanlachnit@debian.org>  Mon, 29 Mar 2021 18:03:56 +0200

=== debian/control ===
Source: ptl
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stephan Lachnit <stephanlachnit@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libtbb-dev,
Rules-Requires-Root: no
Standards-Version: 4.6.0.1
Homepage: https://github.com/jrmadsen/PTL
Vcs-Browser: https://salsa.debian.org/science-team/ptl
Vcs-Git: https://salsa.debian.org/science-team/ptl.git

Package: libptl2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: parallel tasking library
 PTL is a lightweight C++11 multithreading tasking system featuring
 a thread-pool, task-groups, and a lock-free task queue.

Package: libptl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libptl2 (= ${binary:Version}),
 libtbb-dev,
Description: parallel tasking library - development files
 PTL is a lightweight C++11 multithreading tasking system featuring
 a thread-pool, task-groups, and a lock-free task queue.
 .
 This package contains the development files.

=== debian/tests/control ===
Tests: examples
Depends: @, build-essential, cmake
Restrictions: allow-stderr

## ptl 2.3.3

=== CMakeLists.txt ===
# -------------------------------------------------------------------------------------- #
# cmake settings
#
cmake_minimum_required(VERSION 3.8...3.20)
if(${CMAKE_VERSION} VERSION_LESS 3.12)
    cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
endif()

# Warn about an in-source build, but don't error out
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(STATUS "Warning! Building from the source directory is not recommended")
    message(STATUS "If unintented, please remove 'CMakeCache.txt' and 'CMakeFiles'")
    message(STATUS "and build from a separate directory")
    message(WARNING "In-source build")
endif()

# Check if project is being used directly or via add_subdirectory
set(PTL_MASTER_PROJECT ON)
if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(PTL_MASTER_PROJECT OFF)
else()
    set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
endif()

# Version
file(READ "${CMAKE_CURRENT_LIST_DIR}/VERSION" VERSION_STRING LIMIT_COUNT 1)
string(REGEX REPLACE "(\n|\r)" "" VERSION_STRING "${VERSION_STRING}")
string(REGEX REPLACE "[A-Za-z].*" "" VERSION_STRING "${VERSION_STRING}")
set(PTL_VERSION "${VERSION_STRING}")

# -------------------------------------------------------------------------------------- #
# -------------------------------------------------------------------------------------- #
# project setup
#
project(
    PTL
    LANGUAGES C CXX
    VERSION ${PTL_VERSION})

# Postprocess version info to create variables for export to Version.hh
set(PTL_VERSION_STRING "${PTL_VERSION_MAJOR}.${PTL_VERSION_MINOR}.${PTL_VERSION_PATCH}")
math(EXPR PTL_VERSION_CODE
     "10000 * ${PTL_VERSION_MAJOR} + 100 * ${PTL_VERSION_MINOR} + ${PTL_VERSION_PATCH}")

# Project-local CMake settings
set(CMAKE_DIRECTORY_LABELS "PTL")
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)
set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME Development)
set(CMAKE_INSTALL_MESSAGE LAZY)
set(CMAKE_LINK_DEPENDS_NO_SHARED ON)
list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_CURRENT_LIST_DIR}/cmake/Modules)
include(PTLCMakeUtilities)

# -------------------------------------------------------------------------------------- #
# Build/Install settings and options
include(PTLInstallDirs)
include(PTLBuildSettings)

# -------------------------------------------------------------------------------------- #
# User options
ptl_add_option(PTL_USE_TBB "Enable TBB" ON)
ptl_add_option(PTL_USE_LOCKS "Enable mutex locking in task subqueues for extra safety"
               OFF)
ptl_add_option(PTL_INSTALL_HEADERS "Install the headers" ON)
ptl_add_option(PTL_INSTALL_CONFIG "Install the cmake configuration" ON)

if(DEFINED PTL_DEVELOPER_INSTALL)
    set(PTL_INSTALL_HEADERS
        ${PTL_DEVELOPER_INSTALL}
        CACHE BOOL "Set via PTL_DEVELOPER_INSTALL" FORCE)
    set(PTL_INSTALL_CONFIG
        ${PTL_DEVELOPER_INSTALL}
        CACHE BOOL "Set via PTL_DEVELOPER_INSTALL" FORCE)
endif()

# -------------------------------------------------------------------------------------- #
# Build Dependencies - Threads
if(NOT WIN32)
    set(CMAKE_THREAD_PREFER_PTHREAD ON)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
endif()
find_package(Threads REQUIRED)

# * TBB
if(PTL_USE_TBB)
    find_package(TBB 2017 REQUIRED)
endif()

# -------------------------------------------------------------------------------------- #
# PTL Primary Build
add_subdirectory(source)

# -------------------------------------------------------------------------------------- #
# CMake/PkgConfig Support files
include(PTLPackageConfigHelpers)

# -------------------------------------------------------------------------------------- #
# Examples build/test
if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/examples)
    ptl_add_option(PTL_BUILD_EXAMPLES "Build examples" OFF)
    if(PTL_BUILD_EXAMPLES)
        set(PTL_DIR ${CMAKE_BINARY_DIR})
        add_subdirectory(examples)
    endif()
endif()

# -------------------------------------------------------------------------------------- #
# Reporting if master project
if(PTL_MASTER_PROJECT)
    ptl_print_features()
endif()

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # -------------------------------------------------------------------------------------- #
-# # General                                        # #
+# General
 # -------------------------------------------------------------------------------------- #
 # Locate sources and headers for this project - headers are included so they will show up
 # in IDEs
@@ -8,7 +8,7 @@
 file(GLOB_RECURSE ptl_sources ${CMAKE_CURRENT_LIST_DIR}/*.cc)
 
 # -------------------------------------------------------------------------------------- #
-# # Config, Version                                # #
+# Config, Version
 # -------------------------------------------------------------------------------------- #
 
 configure_file(${PROJECT_SOURCE_DIR}/cmake/Templates/Config.hh.in
@@ -22,8 +22,26 @@
 list(APPEND ptl_headers ${CMAKE_CURRENT_BINARY_DIR}/PTL/Version.hh)
 
 # -------------------------------------------------------------------------------------- #
-# # PTL Library                                     # #
+# PTL Library
 # -------------------------------------------------------------------------------------- #
+
+if(BUILD_OBJECT_LIBS)
+
+    ptl_build_library(
+        TYPE OBJECT
+        TARGET_NAME ptl-object
+        OUTPUT_NAME ptl
+        SOURCES ${ptl_headers} ${ptl_sources})
+
+    target_link_libraries(ptl-object PUBLIC Threads::Threads)
+    if(PTL_USE_TBB)
+        target_link_libraries(ptl-object PUBLIC TBB::tbb)
+    endif()
+
+    target_include_directories(
+        ptl-object PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/source>
+                          $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
+endif()
 
 if(BUILD_SHARED_LIBS)
 
@@ -82,7 +100,7 @@
 endif()
 
 # -------------------------------------------------------------------------------------- #
-# # Installation                                    # #
+# Installation
 # -------------------------------------------------------------------------------------- #
 
 if(PTL_INSTALL_CONFIG)

=== examples/basic/CMakeLists.txt ===
# ----------------------------------------------------------------------------
# standard example
#
add_executable(tasking tasking.cc)
target_link_libraries(tasking PRIVATE PTL::ptl common)

if(PTL_TBB_FOUND)
    add_executable(tbb_tasking tasking.cc)
    target_compile_definitions(tbb_tasking PRIVATE USE_TBB_TASKS)
    target_link_libraries(tbb_tasking PTL::ptl common)
endif()

# ----------------------------------------------------------------------------
# recursive example
#
add_executable(recursive_tasking recursive_tasking.cc)
target_link_libraries(recursive_tasking PRIVATE PTL::ptl common)

if(PTL_TBB_FOUND)
    add_executable(recursive_tbb_tasking recursive_tasking.cc)
    target_compile_definitions(recursive_tbb_tasking PRIVATE USE_TBB_TASKS)
    target_link_libraries(recursive_tbb_tasking PTL::ptl common)
endif()

=== examples/common/CMakeLists.txt ===
add_library(common INTERFACE)
target_sources(common INTERFACE utils.hh)
target_include_directories(common INTERFACE ${PROJECT_SOURCE_DIR})

=== examples/minimal/CMakeLists.txt ===
# ----------------------------------------------------------------------------
# minimal example
#
add_executable(ptl-minimal minimal.cc)
target_link_libraries(ptl-minimal PRIVATE PTL::ptl)

=== examples/extended/rotation/CMakeLists.txt ===
# ----------------------------------------------------------------------------
# OpenCV
#
set(OpenCV_COMPONENTS opencv_core opencv_imgproc opencv_highgui)
find_package(OpenCV QUIET COMPONENTS ${OpenCV_COMPONENTS})
if(NOT OpenCV_FOUND)
    message(STATUS "OpenCV not found! Skipping example 'extended/rotation'")
    return()
endif()

# ----------------------------------------------------------------------------
# Data files
#
configure_file(${CMAKE_CURRENT_LIST_DIR}/data/cameraman.tif
               ${CMAKE_BINARY_DIR}/data/cameraman.tif COPYONLY)

# ----------------------------------------------------------------------------
# Build and link executable
#
file(GLOB headers ${CMAKE_CURRENT_LIST_DIR}/source/*.hh)
file(GLOB sources ${CMAKE_CURRENT_LIST_DIR}/source/*.cc)

add_executable(rotation rotation.cc ${sources} ${headers})
target_include_directories(rotation PRIVATE "${CMAKE_CURRENT_LIST_DIR}/source")
target_link_libraries(rotation PUBLIC PTL::ptl ${OpenCV_LIBS} common)

=== debian/changelog ===
ptl (2.3.3-2.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:41:59 +1100

ptl (2.3.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063295

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 21:23:28 +0000

ptl (2.3.3-2) unstable; urgency=medium

  * Fix compilation with GCC12 (Closes: #1016942)
  * Update standards version to 4.6.1, no changes needed

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 10 Aug 2022 10:28:32 +0200

ptl (2.3.3-1) unstable; urgency=medium

  * New upstream version 2.3.3

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 27 May 2022 10:07:13 +0200

ptl (2.3.2-2) unstable; urgency=medium

  * tests: fix using exec

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 22 Apr 2022 14:31:34 +0200

ptl (2.3.2-1) unstable; urgency=medium

  * New upstream version 2.3.2

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 03 Mar 2022 23:46:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,23 @@
 Source: ptl
 Section: libs
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Stephan Lachnit <stephanlachnit@debian.org>
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13),
  cmake,
  libtbb-dev,
 Rules-Requires-Root: no
-Standards-Version: 4.6.0.1
+Standards-Version: 4.6.1
 Homepage: https://github.com/jrmadsen/PTL
 Vcs-Browser: https://salsa.debian.org/science-team/ptl
 Vcs-Git: https://salsa.debian.org/science-team/ptl.git
 
-Package: libptl2
+Package: libptl2t64
+Provides: ${t64:Provides}
+Replaces: libptl2
+Breaks: libptl2 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -29,7 +33,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libptl2 (= ${binary:Version}),
+ libptl2t64 (= ${binary:Version}),
  libtbb-dev,
 Description: parallel tasking library - development files
  PTL is a lightweight C++11 multithreading tasking system featuring

=== debian/watch ===
version=4
https://github.com/jrmadsen/PTL/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
